## ActiveIRC v1.00
## made by jedi
## http://jedi.postboks.org
## #eod on irc.eod.cc
##
## Update a database to use on web-pages
## to list who is online
## 
## INSTALL NOTES
## Import the activeirc.sql and set the settings below
## This script requires fbsql. This module can be found
## at http://www.fastbase.co.nz/fbsql/index.html
##
##############
## Config ####

## Database info
##
set onirc_settings(dbhost) "localhost"
set onirc_settings(dbuser) "ipb"
set onirc_settings(dbpass) "ipb2005"
set onirc_settings(dbdatabase) "forum"
set onirc_settings(dbprefix) "ibf_"

## How often should the database be updated ?
## Update every x minutes
set onirc_settings(updatetime) "1"

## Which channels should we add to table
## "" for every channel
set onirc_settings(channels) ""

## Ignorelist
## Don't show these nicks on the online-table
set onirc_settings(ignorelist) "X W Q $botnick"

## End of config ## 
#################################### 
## Dont touch anything below here ##
#################################### 
load modules/fbsql.so

proc onirc:update { } {
   global onirc_settings

   sql connect $onirc_settings(dbhost) $onirc_settings(dbuser) $onirc_settings(dbpass)
   sql selectdb "$onirc_settings(dbdatabase)"

   foreach chan [channels] {
       set oplist ""
       set nicklist ""
       set doupdate "0"

       foreach nick [chanlist $chan] {
          if {[psearch $onirc_settings(ignorelist) $nick] == 0} {
           if { [isop $nick $chan] == 1 } {
             lappend oplist "@$nick";
           } else {
             lappend nicklist "$nick"            
           }
         }
       }


     if { $onirc_settings(channels) == "" } {
       set doupdate "1"
     } else {
       if {[lsearch -exact [string tolower $onirc_settings(channels)] [string tolower $chan]] != -1 } {
         set doupdate "1"
       }
     }
     

     if { $doupdate == "1" } {
       sql "SELECT id FROM $onirc_settings(dbprefix)activeirc WHERE chan='$chan'"
       if { [ sql numrows ] == 0 } {
        ## Channel record doesn't exists, create.
        sql "INSERT INTO $onirc_settings(dbprefix)activeirc(chan) VALUES('$chan')"
       }
       set timestamp [exec date +%s]
       if { [string length $oplist] > 0 } {
        set nicklist "$oplist $nicklist"
       }
       sql "UPDATE $onirc_settings(dbprefix)activeirc SET online='$nicklist',updated='$timestamp' WHERE chan='$chan'"
     }
   }

   sql disconnect
   timer $onirc_settings(updatetime) onirc:update
}

proc psearch { pattern_list match } {
   foreach pattern $pattern_list {
     if {[string match [string tolower $pattern] [string tolower $match]] == 1} {
       return 1
     } 
   }
   return 0
}

if {![info exists onirc_loaded]} {
  timer $onirc_settings(updatetime) onirc:update
  set onirc_loaded 1
}
